package com.netcertainty.webtier.b2b.pushevents;

import javax.ws.rs.client.Entity;
import javax.ws.rs.core.MediaType;

import org.jboss.resteasy.client.jaxrs.ResteasyClient;
import org.jboss.resteasy.client.jaxrs.ResteasyClientBuilder;
import org.jboss.resteasy.client.jaxrs.ResteasyWebTarget;
import org.jboss.resteasy.client.jaxrs.engines.URLConnectionEngine;

public class NotificationClient {
	
	String url;
	
	public NotificationClient(){		
	}
	
	public NotificationClient(String destination){	
		url = destination;
	}
	
	public String complete(String txId) throws Exception{
		
		boolean isV2 = (url!=null) && url.indexOf("?action=")>0;
		String target = url;
		if(!isV2)
			target = url +"/"+txId;
		
		System.out.println("target: "+target);
/*		ClientRequest cr = new ClientRequest(target);
		
		//Ziplogix requested to set the accept header for .Net
	    cr.accept("application/json");	
	    
	    Response response = cr.get(Response.class).getEntity();
		//System.out.println("Notify client response : " + response);
		return response;
*/
		URLConnectionEngine engine = new URLConnectionEngine();
		ResteasyClient client = new ResteasyClientBuilder().httpEngine(engine).build();
		
		 ResteasyWebTarget webTarget = client.target(target);
		 javax.ws.rs.core.Response response = webTarget.request().get();
	     //Read output in string format
	     String value = response.readEntity(String.class);
	     System.out.println("Response: "+value);
	     response.close(); 
	   	
		 return value;
	}
	/*
	public String sendInfo(String target, EventInfo info) throws Exception{
		
		URLConnectionEngine engine = new URLConnectionEngine();
		ResteasyClient client = new ResteasyClientBuilder().httpEngine(engine).build();
		
		 ResteasyWebTarget webTarget = client.target(target);
		 javax.ws.rs.core.Response response = webTarget.request().post(Entity.entity(info,MediaType.APPLICATION_JSON));
	     //Read output in string format
	     String value = response.readEntity(String.class);
	     //System.out.println("Response: "+value);
	     response.close(); 
	   	
		 return value;
	}
	*/
	public static void main(String[] args)
	{
		String url = (args.length > 0) ? args[0] : "http://localhost:8080/restservices/notification/version2?action=send&id=12345:324&ts=20141016113123";
		String tx = (args.length > 1) ? args[1] : "test_tx_4321";
		try
		{
			NotificationClient client = new NotificationClient(url);
			System.out.println(client.complete(tx));
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
